export interface LinkPlain<Ref extends number> {
    id: Ref;
    type_id: Ref;
    from_id: Ref;
    to_id: Ref;
}
export interface LinkRelations<L> {
    typed: L[];
    type: L;
    in: L[];
    inByType: {
        [id: number]: L[];
    };
    out: L[];
    outByType: {
        [id: number]: L[];
    };
    from: L;
    to: L;
}
export interface Link<Ref extends number> extends LinkPlain<Ref>, LinkRelations<Link<Ref>> {
    [key: string]: any;
}
export interface MinilinksResult<Link> {
    links: Link[];
    types: {
        [id: number]: Link[];
    };
    byId: {
        [id: number]: Link;
    };
    options: MinilinksGeneratorOptions;
}
export interface MinilinksGeneratorOptions {
    id: string;
    type_id: string;
    type: string;
    typed: string;
    from_id: string;
    from: string;
    out: string;
    to_id: string;
    to: string;
    in: string;
    inByType: string;
    outByType: string;
    handler?: (link: any, result: any) => any;
}
export declare const MinilinksGeneratorOptionsDefault: MinilinksGeneratorOptions;
export interface MinilinksInstance<L extends Link<number>> {
    (linksArray: L[], memory?: MinilinksResult<L>): MinilinksResult<L>;
}
export declare function Minilinks<MGO extends MinilinksGeneratorOptions, L extends Link<number>>(options: MGO): MinilinksInstance<L>;
export declare const minilinks: MinilinksInstance<Link<number>>;
