"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_tag_1 = __importDefault(require("graphql-tag"));
const gists_1 = __importDefault(require("gists"));
const client_1 = require("@deep-foundation/hasura/client");
const packager_1 = require("../packager");
const apollo_server_express_1 = require("apollo-server-express");
const client_2 = require("../client");
const gists = new gists_1.default({
    username: 'ivansglazunov',
    password: 'Isg3173Github',
});
const client = (0, client_1.generateApolloClient)({
    path: `${process.env.MIGRATIONS_HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.MIGRATIONS_HASURA_SSL,
    secret: process.env.MIGRATIONS_HASURA_SECRET,
});
const packager = new packager_1.Packager(new client_2.DeepClient({ apolloClient: client }));
const typeDefs = (0, graphql_tag_1.default) `
  type Query {
    packagerInstall(input: PackagerInstallInput): PackagerInstallOutput
    packagerPublish(input: PackagerPublishInput): PackagerPublishOutput
  }
  input PackagerInstallInput {
    name: String
    version: String
    uri: String
    type: String
  }
  type PackagerInstallOutput {
    ids: [Int]
    errors: [String]
  }
  input PackagerPublishInput {
    id: Int
    uri: String
    type: String
  }
  type PackagerPublishOutput {
    errors: [String]
  }
`;
const resolvers = {
    Query: {
        packagerInstall: (source, args, context, info) => __awaiter(void 0, void 0, void 0, function* () {
            var _a, _b;
            const { name, version, uri, type } = args.input;
            const errors = [];
            if (type === 'gist') {
                const result = yield gists.get('4cf14e3e58f4e96f7e7914b963ecdd29');
                const files = (_a = result === null || result === void 0 ? void 0 : result.body) === null || _a === void 0 ? void 0 : _a.files;
                const deepPckgContent = (_b = files === null || files === void 0 ? void 0 : files['deep.pckg']) === null || _b === void 0 ? void 0 : _b.content;
                if (deepPckgContent) {
                    try {
                        const deepPckg = JSON.parse(deepPckgContent);
                        const { ids, errors } = yield packager.import(deepPckg);
                        return { ids, errors };
                    }
                    catch (error) {
                        errors.push(error);
                    }
                }
                else {
                    errors.push(`deep.pckg not founded in gist`);
                }
            }
            return { ids: [], errors };
        }),
        packagerPublish: (source, args, context, info) => __awaiter(void 0, void 0, void 0, function* () {
            const { id, uri, type } = args.input;
            if (type === 'gist') {
            }
            const errors = [];
            return { errors };
        }),
    }
};
const context = ({ req }) => {
    return { headers: req.headers };
};
const apolloServer = new apollo_server_express_1.ApolloServer({ introspection: true, typeDefs, resolvers, context });
exports.default = apolloServer;
//# sourceMappingURL=packager.js.map