"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const index_1 = __importDefault(require("./imports/router/index"));
const jwt_1 = __importDefault(require("./imports/router/jwt"));
const guest_1 = __importDefault(require("./imports/router/guest"));
const packager_1 = __importDefault(require("./imports/router/packager"));
const app = (0, express_1.default)();
app.use(express_1.default.json());
app.use('/', index_1.default);
app.listen(process.env.PORT, () => {
    console.log(`Hello bugfixers! Listening ${process.env.PORT} port`);
});
const start = () => __awaiter(void 0, void 0, void 0, function* () {
    yield jwt_1.default.start();
    yield guest_1.default.start();
    yield packager_1.default.start();
    jwt_1.default.applyMiddleware({ path: '/api/jwt', app });
    guest_1.default.applyMiddleware({ path: '/api/guest', app });
    packager_1.default.applyMiddleware({ path: '/api/packager', app });
});
start();
//# sourceMappingURL=index.js.map