"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.testSeparation2 = exports.testSeparation1 = exports.testRecursiveSameRoot = exports.testRecursive = exports.testPlus15 = exports.testMinus15 = exports.prepare = exports.beforeAllHandler = void 0;
require('dotenv').config();
const debug_1 = __importDefault(require("debug"));
const chance_1 = __importDefault(require("chance"));
const chance = new chance_1.default();
const debug = (0, debug_1.default)('materialized-path:test');
const SCHEMA = process.env.MIGRATIONS_SCHEMA || 'public';
const MP_TABLE = process.env.MIGRATIONS_MP_TABLE || 'mp_example__links__mp_md';
const GRAPH_TABLE = process.env.MIGRATIONS_GRAPH_TABLE || 'mp_example__links_md';
const ID_TYPE = process.env.MIGRATIONS_ID_TYPE_GQL || 'Int';
const DELAY = +process.env.DELAY || 0;
const delay = time => new Promise(res => setTimeout(res, time));
const itDelay = () => {
    if (DELAY) {
        (it)('delay', () => __awaiter(void 0, void 0, void 0, function* () {
            yield delay(DELAY);
        }));
    }
};
const beforeAllHandler = () => { };
exports.beforeAllHandler = beforeAllHandler;
const prepare = () => { };
exports.prepare = prepare;
const testMinus15 = (x) => () => __awaiter(void 0, void 0, void 0, function* () { });
exports.testMinus15 = testMinus15;
const testPlus15 = (x) => () => __awaiter(void 0, void 0, void 0, function* () { });
exports.testPlus15 = testPlus15;
const testRecursive = (x) => () => __awaiter(void 0, void 0, void 0, function* () { });
exports.testRecursive = testRecursive;
const testRecursiveSameRoot = (x) => () => __awaiter(void 0, void 0, void 0, function* () { });
exports.testRecursiveSameRoot = testRecursiveSameRoot;
const testSeparation1 = (x) => () => __awaiter(void 0, void 0, void 0, function* () { });
exports.testSeparation1 = testSeparation1;
const testSeparation2 = (x) => () => __awaiter(void 0, void 0, void 0, function* () { });
exports.testSeparation2 = testSeparation2;
beforeAll(exports.beforeAllHandler);
(it)('prepare', exports.prepare);
it('+15', (0, exports.testPlus15)(true));
itDelay();
it('-15', (0, exports.testMinus15)(true));
itDelay();
it('recursive', (0, exports.testRecursive)(true));
itDelay();
it('recursiveSameRoot', (0, exports.testRecursiveSameRoot)(true));
itDelay();
it('testSeparation1', (0, exports.testSeparation1)(true));
itDelay();
it('testSeparation2', (0, exports.testSeparation2)(true));
//# sourceMappingURL=multidirectional.js.map